﻿// Spikies - Jim Bumgardner

SW = Stage.width;
SH = Stage.height;

COLUMNS = 12;
ROWS = 9;
TILE_X = SW/COLUMNS;
TILE_Y = (SH-100)/ROWS;
LASTCOL = COLUMNS - 1;
LASTROW = ROWS - 1;
SHAPES_PER_PASS = 8;	// number of pixels to color each pass
DEG_120 = 120*Math.PI/180;
DEG_240 = 240*Math.PI/180;

saturation = .5;
wobbleFreq = .05;
isFaded = false;
rotSpeed = 2;
hasHetero = false;

MovieClip.prototype.drawPixel = function()
{
	this.clear();
	this.moveTo(0,0);
	this.beginFill(0x0077FF);
	var cx = TILE_X/2;
	var cy = TILE_Y/2;
	this.curveTo(cx,cy,0+TILE_X,0);
	this.curveTo(cx,cy,0+TILE_X,0+TILE_Y);
	this.curveTo(cx,cy,0,0+TILE_Y);
	this.curveTo(cx,cy,0,0);
	this.endFill();
}

function updatePixels()
{
	for (var i = 0; i < SHAPES_PER_PASS; ++i) {
		var x = Math.floor(Math.random()*COLUMNS);
		var y = Math.floor(Math.random()*ROWS);
		var t = getTimer()*.001;
		var r = 128+Math.sin(t)*127;
		var g = 128+Math.sin(t + saturation*DEG_120)*127;
		var b = 128+Math.sin(t + saturation*DEG_240)*127;
		var tint = (r << 16) | (g << 8) | b;

		this["pix_" + x + "_" + y].itsColor.setRGB(tint);
		this["pix_" + x + "_" + y]._alpha = isFaded? 50 : 100;
	}
}

var n = 0;
// this.attachMovie("dmy","framer",0);
for (var i = 0; i < COLUMNS; ++i) {
	for (var j = 0; j < ROWS; ++j) {
		var h = canvas_mc.createEmptyMovieClip("pix_" + i + "_" + j, n++);
		h._x = i * TILE_X;
		h._y = j * TILE_Y;
		h._rotation = Math.random()*360;
		h.heteroSpin = Math.random()*10-5;
		h._width = TILE_X;
		h._height = TILE_Y;
		var r = Math.random();
		h.drawPixel();
		h.itsColor = new Color(h);
		h.onEnterFrame = function ()
		{
			this._width = TILE_X+TILE_X*Math.sin((this._x + getTimer()*.001*wobbleFreq)*.5)*4;
			this._height = TILE_X+TILE_X*Math.cos((this._y + getTimer()*.001*wobbleFreq)*.5)*4;
			this._rotation += this.heteroSpin*hasHetero+rotSpeed;
		};
	}
}
canvas_mc.onEnterFrame = updatePixels;


#include "jbumUI.as"

button_faded.setupToggleButton("faded", isFaded, function(t) { isFaded = t; },true);
button_hetero.setupToggleButton("hetero", hasHetero, function(t) { hasHetero = t; },true);
colorslider_mc.setupSlider('saturation',0,1, saturation,function(t) { saturation = t;  } );
wobbleslider_mc.setupSlider('wobble',0,4, wobbleFreq,function(t) { wobbleFreq = t;  } );
rotslider_mc.setupSlider('rotation',-10,10, rotSpeed,function(t) { rotSpeed = t;  } );

